diff --git a/resultsdb_frontend/controllers/main.py b/resultsdb_frontend/controllers/main.py
--- a/resultsdb_frontend/controllers/main.py
+++ b/resultsdb_frontend/controllers/main.py
@@ -35,36 +35,37 @@
 @main.route('/')
 @main.route('/index')
 def index():
-     return redirect(url_for('main.jobs'))
+     return redirect(url_for('main.results'))
 
-@main.route('/jobs')
-def jobs():
-    jobs = rdb_api.get_jobs(**dict(request.args))
-    return render_template('jobs.html', jobs = jobs)
+@main.route('/groups')
+def groups():
+    groups = rdb_api.get_groups(**dict(request.args))
+    return render_template('groups.html', groups = groups)
 
-@main.route('/jobs/<job_id>')
-def job(job_id):
+@main.route('/groups/<group_id>')
+def group(group_id):
     try:
-        job = rdb_api.get_job(id = job_id)
+        group = rdb_api.get_groups(group_id)
     except ResultsDBapiException as e:
         return str(e)
-    jobs = dict(prev = None, next = None, data = [job])
-    return render_template('jobs.html', jobs = jobs)
+    groups = dict(prev = None, next = None, data = [group])
+    return render_template('groups.html', groups = groups)
 
 @main.route('/results')
 def results():
     args = dict(request.args)
-    if 'job_id' in args:
-        args['job_id'] = request.args['job_id']
     results = rdb_api.get_results(**args)
+    for result in results['data']:
+        result['groups'] = (len(result['groups']), ','.join([r.split('/')[-1].strip() for r in result['groups']]))
     return render_template('results.html', results = results)
 
 @main.route('/results/<result_id>')
 def result(result_id):
     try:
         result = rdb_api.get_result(id = result_id)
     except ResultsDBapiException as e:
         return str(e)
+    result['groups'] = (len(result['groups']), ','.join([r.split('/')[-1].strip() for r in result['groups']]))
     return render_template('result_detail.html', result = result)
 
 @main.route('/testcases')
diff --git a/resultsdb_frontend/templates/groups.html b/resultsdb_frontend/templates/groups.html
new file mode 100644
--- /dev/null
+++ b/resultsdb_frontend/templates/groups.html
@@ -0,0 +1,42 @@
+{% extends "layout.html" %}
+
+{% block body %}
+<table class="table table-striped table-bordered">
+    <thead>
+      <tr>
+        <th>Group</th>
+        <th>Results</th>
+        <th>Logs</th>
+      </tr>
+    </thead>
+    <tbody>
+    {% for group in groups.data %}
+      <tr>
+        <td>
+          {% if group.description %}
+            {{ group.description }}
+            <a href="#{{group.uuid}}" class="btn btn-xs btn-info" style="float: right" data-toggle="collapse">Show UUID</a>
+            <div id="{{group.uuid}}" class="collapse">{{group.uuid}}</div>
+          {% else %}
+            {{ group.uuid }}
+          {% endif %}
+        </td>
+        <td><a href="{{ url_for('main.results', groups = group.uuid) }}">{{ group.results_count }} results</a></td>
+        <td><a href="{{ group.ref_url }}">Link &rarr;</a></td>
+      </tr>
+    {% endfor %}
+    </tbody>
+</table>
+
+
+<ul class="pager">
+  {% if groups.prev %}
+    <li class="previous"><a href="{{ url_for('main.groups') }}?{{ groups.prev.split('?')[-1] }}">&larr; Newer groups</a></li>
+  {% endif %}
+  {% if groups.next %}
+    <li class="next"><a href="{{ url_for('main.groups') }}?{{ groups.next.split('?')[-1] }}">Older groups &rarr;</a></li>
+  {% endif %}
+</ul>
+
+
+{% endblock %}
diff --git a/resultsdb_frontend/templates/jobs.html b/resultsdb_frontend/templates/jobs.html
deleted file mode 100644
--- a/resultsdb_frontend/templates/jobs.html
+++ /dev/null
@@ -1,38 +0,0 @@
-{% extends "layout.html" %}
-
-{% block body %}
-<table class="table table-striped table-bordered">
-    <thead>
-      <tr>
-        <th>ID</th>
-        <th>Start time (UTC)</th>
-        <th>Name</th>
-        <th>Results</th>
-        <th>Job Details</th>
-      </tr>
-    </thead>
-    <tbody>
-    {% for job in jobs.data %}
-      <tr>
-        <td>{{ job.id }}</td>
-        <td>{{ job.start_time | replace("T", " ")}}</td>
-        <td>{{ job.name }}</td>
-        <td><a href="{{ url_for('main.results', job_id = job.id) }}">{{ job.results_count }} results</a></td>
-        <td><a href="{{ job.ref_url }}">Info &rarr;</a></td>
-      </tr>
-    {% endfor %}
-    </tbody>
-</table>
-
-
-<ul class="pager">
-  {% if jobs.prev %}
-    <li class="previous"><a href="{{ url_for('main.jobs') }}?{{ jobs.prev.split('?')[-1] }}">&larr; Newer Jobs</a></li>
-  {% endif %}
-  {% if jobs.next %}
-    <li class="next"><a href="{{ url_for('main.jobs') }}?{{ jobs.next.split('?')[-1] }}">Older Jobs &rarr;</a></li>
-  {% endif %}
-</ul>
-
-
-{% endblock %}
diff --git a/resultsdb_frontend/templates/layout.html b/resultsdb_frontend/templates/layout.html
--- a/resultsdb_frontend/templates/layout.html
+++ b/resultsdb_frontend/templates/layout.html
@@ -23,9 +23,9 @@
         <div class="navbar-collapse collapse">
 
           <ul class="nav navbar-nav">
-              <li><a href="{{ url_for('main.jobs') }}">Jobs</a></li>
               <li><a href="{{ url_for('main.results') }}">Results</a></li>
               <li><a href="{{ url_for('main.testcases') }}">Testcases</a></li>
+              <li><a href="{{ url_for('main.groups') }}">Groups</a></li>
           </ul>
 
           <form class="navbar-form navbar-right" role="search">
diff --git a/resultsdb_frontend/templates/result_detail.html b/resultsdb_frontend/templates/result_detail.html
--- a/resultsdb_frontend/templates/result_detail.html
+++ b/resultsdb_frontend/templates/result_detail.html
@@ -6,7 +6,7 @@
     <div class="col-md-9">{{ result.id }}</div>
 </div>
 <div class="row">
-    <div class="col-md-2"><strong>Submit time</strong></div>
+    <div class="col-md-2"><strong>Submitted</strong></div>
     <div class="col-md-9">{{ result.submit_time | replace("T", " ")}}</div>
 </div>
 <div class="row">
@@ -18,25 +18,27 @@
     <div class="col-md-9">{{ result.outcome }}</div>
 </div>
 <div class="row">
-    <div class="col-md-2"><strong>Summary</strong></div>
-    <div class="col-md-9">{{ result.summary }}</div>
+    <div class="col-md-2"><strong>Note</strong></div>
+    <div class="col-md-9">{{ result.note }}</div>
 </div>
 <div class="row">
-    <div class="col-md-2"><strong>Job</strong></div>
-    <div class="col-md-9"><a href="{{ url_for('main.job', job_id=result.job_url.split('/')[-1]) }}">Job</a></div>
+    <div class="col-md-2"><strong>Groups</strong></div>
+    <div class="col-md-9">
+      <a href="{{ url_for('main.groups', uuid=result.groups[1])}}">In {{result.groups[0]}} group{%if result.groups[0] != 1%}s{%endif%}</a>
+    </div>
 </div>
 <div class="row">
-    <div class="col-md-2"><strong>Log</strong></div>
-    <div class="col-md-9"><a href="{{ result.log_url }}">Log &rarr;</a></div>
+    <div class="col-md-2"><strong>Logs</strong></div>
+    <div class="col-md-9"><a href="{{ result.ref_url }}">Link &rarr;</a></div>
 </div>
 <div class="row">
     <div class="col-md-12">&nbsp;</div>
 </div>
 
-{% for key in result.result_data %}
+{% for key in result.data %}
 <div class="row">
     <div class="col-md-2"><strong>{{key}}</strong></div>
-    <div class="col-md-9">{{', '.join(result.result_data[key])}}</div>
+    <div class="col-md-9">{{', '.join(result.data[key])}}</div>
 </div>
 {% endfor %}
 
diff --git a/resultsdb_frontend/templates/results.html b/resultsdb_frontend/templates/results.html
--- a/resultsdb_frontend/templates/results.html
+++ b/resultsdb_frontend/templates/results.html
@@ -4,41 +4,41 @@
 <table class="table table-striped table-bordered">
     <thead>
       <tr>
-        <th>ID</th>
-        <th>Submit time (UTC)</th>
+        <th>Submitted (UTC)</th>
         <th>Testcase</th>
         <th>Outcome</th>
         <th>Item</th>
         <th>Note</th>
         <th>Details</th>
-        <th>Job</th>
-        <th>Log</th>
+        <th>Groups</th>
+        <th>Logs</th>
       </tr>
     </thead>
     <tbody>
     {% for result in results.data %}
       <tr>
-        <td>{{ result.id }}</td>
         <td>{{ result.submit_time | replace("T", " ")}}</td>
         <td><a href="{{ url_for('main.testcase', testcase_name=result.testcase.href.split('/')[-1]) }}">{{ result.testcase.name }}</a></td>
         <td>{{ result.outcome }}</td>
         <td>
-          {% if result.result_data.item %}
-              {{ ",".join(result.result_data.item) }}
+          {% if result.data.item %}
+              {{ ",".join(result.data.item) }}
           {% else %}
               -
           {% endif %}
         </td>
         <td>
-          {% if result.summary %}
-              {{ result.summary }}
+          {% if result.note %}
+              {{ result.note }}
           {% else %}
               &nbsp;
           {% endif %}
         </td>
         <td><a href="{{ url_for('main.result', result_id=result.id) }}">Details</a></td>
-        <td><a href="{{ url_for('main.job', job_id=result.job_url.split('/')[-1]) }}">Job</a></td>
-        <td><a href="{{ result.log_url }}">Log &rarr;</a></td>
+        <td>
+          <a href="{{ url_for('main.groups', uuid=result.groups[1])}}">In {{result.groups[0]}} group{%if result.groups[0] != 1%}s{%endif%} &rarr;</a>
+        </td>
+        <td><a href="{{ result.ref_url }}">Link &rarr;</a></td>
       </tr>
     {% endfor %}
     </tbody>
diff --git a/resultsdb_frontend/templates/testcases.html b/resultsdb_frontend/templates/testcases.html
--- a/resultsdb_frontend/templates/testcases.html
+++ b/resultsdb_frontend/templates/testcases.html
@@ -6,15 +6,15 @@
       <tr>
         <th>Name</th>
         <th>Results</th>
-        <th>Description</th>
+        <th>Info</th>
       </tr>
     </thead>
     <tbody>
     {% for testcase in testcases.data %}
       <tr>
         <td>{{ testcase.name }}</td>
-        <td><a href="{{ url_for('main.results', testcase_name = testcase.name) }}">Results</a></td>
-        <td><a href="{{ testcase.url }}">Ref &rarr;</a></td>
+        <td><a href="{{ url_for('main.results', testcases = testcase.name) }}">Results</a></td>
+        <td><a href="{{ testcase.url }}">Link &rarr;</a></td>
       </tr>
     {% endfor %}
     </tbody>