Index: conf/trigger.cfg.example
===================================================================
--- conf/trigger.cfg.example
+++ conf/trigger.cfg.example
@@ -9,3 +9,4 @@
 valid_arches = i386,i686,x86_64,noarch
 koji_url = http://koji.fedoraproject.org/kojihub
 type = StreamTrigger
+blacklist_releases = el5,el6
Index: jobtriggers/bodhi_msg.py
===================================================================
--- jobtriggers/bodhi_msg.py
+++ jobtriggers/bodhi_msg.py
@@ -20,13 +20,18 @@
         usable_message = fedmsg.encoding.loads(message.body)
 
         topic = usable_message['topic']
+        builds = usable_message['msg']['update']['builds']
+        nvrs = [build['nvr'] for build in builds]
 
+        # we want only requests to stable and testing
         if not topic.endswith('stable') and not topic.endswith('testing'):
             return
 
+        # do not schledule jobs for blacklisted releases
+        if nvrs[0].endswith(tuple(config.blacklist_releases)):
+            return
+
         updatetitle = usable_message['msg']['update']['title']
-        builds = usable_message['msg']['update']['builds']
-        nvrs = [build['nvr'] for build in builds]
 
         arches = utils.get_arches(nvr=nvrs[0])
 
Index: jobtriggers/config.py
===================================================================
--- jobtriggers/config.py
+++ jobtriggers/config.py
@@ -13,6 +13,7 @@
 valid_arches = i386,i686,x86_64,noarch
 koji_url = http://koji.fedoraproject.org/kojihub
 type = StreamTrigger
+blacklist_releases = el5,el6
 """
 
 config = ConfigParser.ConfigParser()
@@ -29,3 +30,4 @@
 valid_arches = [e.strip() for e in config.get('trigger', 'valid_arches').split(',')]
 koji_url = config.get('trigger', 'koji_url')
 trigger_type = config.get('trigger', 'type')
+blacklist_releases = [e.strip() for e in config.get('trigger', 'blacklist_releases').split(',')]
Index: jobtriggers/koji_msg.py
===================================================================
--- jobtriggers/koji_msg.py
+++ jobtriggers/koji_msg.py
@@ -20,16 +20,21 @@
         usable_message = fedmsg.encoding.loads(message.body)
 
         tag = usable_message['msg']['tag']
+        release = usable_message['msg']['release']
 
+        # we look only for pending builds
         if not tag.endswith('pending'):
             return
 
-        buildname = usable_message['msg']['name']
-        buildversion = usable_message['msg']['version']
-        buildrelease = usable_message['msg']['release']
+        # do not schledule jobs for blacklisted releases
+        if release.endswith(tuple(config.blacklist_releases)):
+            return
+
+        name = usable_message['msg']['name']
+        version = usable_message['msg']['version']
         buildid = usable_message['msg']['build_id']
 
-        envr = "%s-%s-%s" % (buildname, buildversion, buildrelease)
+        envr = "%s-%s-%s" % (name, version, release)
 
         arches = utils.get_arches(buildid=buildid)
 
Index: testing/test_bodhi_trigger.py
===================================================================
--- testing/test_bodhi_trigger.py
+++ testing/test_bodhi_trigger.py
@@ -7,29 +7,35 @@
 class TestBodhiJobTrigger():
     def setup_method(self, method):
         self.ref_updatetitle = 'foo'
+        self.ref_nvr = "gnome-settings-daemon-3.6.1-1.fc18"
         self.ref_topic = 'org.fedoraproject.prod.bodhi.update.request.stable'
 
         self.ref_tasks = ['bodhi_task1', 'bodhi_task2']
         self.ref_validarches = ['i386', 'x86_64']
+        self.ref_blacklist_releases= ['el5', 'el6']
 
-        self._create_msg(self.ref_updatetitle, self.ref_topic)
+        self._create_msg(self.ref_updatetitle, self.ref_nvr, self.ref_topic)
 
-        self.helper = bodhi_msg.BodhiJobTrigger(Dingus())
+        stub_hub = Bunch(config=Bunch(get=0))
+        self.helper = bodhi_msg.BodhiJobTrigger(stub_hub)
 
-    def _create_msg(self, ref_updatetitle, ref_topic):
+        self.helper.trigger = Dingus()
+
+        bodhi_msg.utils = Dingus(get_arches__returns=self.ref_validarches)
+
+        bodhi_msg.config.bodhi_tasks = self.ref_tasks
+        bodhi_msg.config.valid_arches = self.ref_validarches
+        bodhi_msg.config.blacklist_releases = self.ref_blacklist_releases
+
+    def _create_msg(self, ref_updatetitle, ref_nvr, ref_topic):
         self.ref_message = Bunch(body='{"msg": {"agent": "lmacken",\
                                         "update": {"submitter": "lmacken",\
                                                    "title": "%s",\
-                                                   "builds": [{"nvr": "gnome-settings-daemon-3.6.1-1.fc18"}]}},\
+                                                   "builds": [{"nvr": "%s"}]}},\
                                         "topic": "%s"}' %
-                                        (ref_updatetitle, ref_topic))
-
-    def test_consume(self, monkeypatch):
-        monkeypatch.setattr(self.helper, 'trigger', Dingus())
-        monkeypatch.setattr(bodhi_msg.config, 'bodhi_tasks', self.ref_tasks)
-        monkeypatch.setattr(bodhi_msg.config, 'valid_arches', self.ref_validarches)
-        monkeypatch.setattr(bodhi_msg, 'utils', Dingus(get_arches__returns=self.ref_validarches))
+                                        (ref_updatetitle, ref_nvr, ref_topic))
 
+    def test_consume(self):
         self.helper.consume(self.ref_message)
 
         trigger_calls = self.helper.trigger.trigger_job.calls()
@@ -41,11 +47,19 @@
         assert trigger_calls[2][1] == (self.ref_updatetitle, bodhi_msg.UNIT_TYPE, self.ref_tasks[1], self.ref_validarches[0])
         assert trigger_calls[3][1] == (self.ref_updatetitle, bodhi_msg.UNIT_TYPE, self.ref_tasks[1], self.ref_validarches[1])
 
-    def test_consume_notwatched_topic(self, monkeypatch):
+    def test_consume_notwatched_topic(self):
         ref_topic = 'org.fedoraproject.pro.bodhi.update.request.randomtopic'
-        self._create_msg(self.ref_updatetitle, ref_topic)
+        self._create_msg(self.ref_updatetitle, self.ref_nvr, ref_topic)
+
+        self.helper.consume(self.ref_message)
+
+        trigger_calls = self.helper.trigger.trigger_job.calls()
+
+        assert trigger_calls == []
 
-        monkeypatch.setattr(self.helper, 'trigger', Dingus())
+    def test_consume_blacklisted_release(self):
+        ref_nvr = 'gnome-settings-daemon-3.6.1-1.el5'
+        self._create_msg(self.ref_updatetitle, ref_nvr, self.ref_topic)
 
         self.helper.consume(self.ref_message)
 
Index: testing/test_koji_trigger.py
===================================================================
--- testing/test_koji_trigger.py
+++ testing/test_koji_trigger.py
@@ -16,8 +16,18 @@
 
         self.ref_tasks = ['koji_task1', 'koji_task2']
         self.ref_validarches = ['i386', 'x86_64']
+        self.ref_blacklist_releases= ['el5', 'el6']
 
-        self.helper = koji_msg.KojiJobTrigger(Dingus())
+        stub_hub = Bunch(config=Bunch(get=0))
+
+        self.helper = koji_msg.KojiJobTrigger(stub_hub)
+        self.helper.trigger = Dingus()
+
+        koji_msg.utils = Dingus(get_arches__returns=self.ref_validarches)
+
+        koji_msg.config.koji_tasks = self.ref_tasks
+        koji_msg.config.valid_arches = self.ref_validarches
+        koji_msg.config.blacklist_releases = self.ref_blacklist_releases
 
     def _create_msg(self, ref_name, ref_release, ref_tag, ref_version):
         self.ref_message = Bunch(body='{"i": 1,\
@@ -34,12 +44,7 @@
                                         "username": "apache"}' %
                                         (ref_name, ref_release, ref_tag, ref_version))
 
-    def test_consume(self, monkeypatch):
-        monkeypatch.setattr(self.helper, 'trigger', Dingus())
-        monkeypatch.setattr(koji_msg.config, 'koji_tasks', self.ref_tasks)
-        monkeypatch.setattr(koji_msg.config, 'valid_arches', self.ref_validarches)
-        monkeypatch.setattr(koji_msg, 'utils', Dingus(get_arches__returns=self.ref_validarches))
-
+    def test_consume(self):
         self.helper.consume(self.ref_message)
 
         trigger_calls = self.helper.trigger.trigger_job.calls()
@@ -51,11 +56,20 @@
         assert trigger_calls[2][1] == (self.ref_nvr, koji_msg.UNIT_TYPE, self.ref_tasks[1], self.ref_validarches[0])
         assert trigger_calls[3][1] == (self.ref_nvr, koji_msg.UNIT_TYPE, self.ref_tasks[1], self.ref_validarches[1])
 
-    def test_consume_notwatched_tag(self, monkeypatch):
+    def test_consume_notwatched_tag(self):
         ref_tag = 'f18-randomtag'
         self._create_msg(self.ref_name, self.ref_release, ref_tag, self.ref_version)
 
-        monkeypatch.setattr(self.helper, 'trigger', Dingus())
+        self.helper.consume(self.ref_message)
+
+        trigger_calls = self.helper.trigger.trigger_job.calls()
+
+        assert trigger_calls == []
+
+    def test_consume_blacklisted_release(self):
+        ref_release = '3.el5'
+        self._create_msg(self.ref_name, ref_release, self.ref_tag, self.ref_version)
+
         self.helper.consume(self.ref_message)
 
         trigger_calls = self.helper.trigger.trigger_job.calls()