diff --git a/resultsdb/controllers/api_v2.py b/resultsdb/controllers/api_v2.py
--- a/resultsdb/controllers/api_v2.py
+++ b/resultsdb/controllers/api_v2.py
@@ -224,7 +224,7 @@
     try:
         args = RP['get_groups'].parse_args()
     except JSONBadRequest as error:
-        return jsonify({"message": "Malformed Request"}), error.code
+        return jsonify({"message": "Malformed Request: %s" % error.data['message']}), error.code
     except HTTPException as error:
         return jsonify(error.data), error.code
 
@@ -280,7 +280,7 @@
     try:
         args = RP['create_group'].parse_args()
     except JSONBadRequest as error:
-        return jsonify({"message": "Malformed Request"}), error.code
+        return jsonify({"message": "Malformed Request: %s" % error.data['message']}), error.code
     except HTTPException as error:
         return jsonify(error.data), error.code
 
@@ -368,7 +368,7 @@
     try:
         args = RP['get_results'].parse_args()
     except JSONBadRequest as error:
-        retval["error"] = (jsonify({"message": "Malformed Request"}), error.code)
+        retval["error"] = (jsonify({"message": "Malformed Request: %s" % error.data['message']}), error.code)
         return retval
     except HTTPException as error:
         retval["error"] = (jsonify(error.data), error.code)
@@ -540,7 +540,7 @@
     try:
         args = RP['create_result'].parse_args()
     except JSONBadRequest as error:
-        return jsonify({"message": "Malformed Request"}), error.code
+        return jsonify({"message": "Malformed Request: %s" % error.data['message']}), error.code
     except HTTPException as error:
         return jsonify(error.data), error.code
 
@@ -696,7 +696,7 @@
     try:
         args = RP['get_testcases'].parse_args()
     except JSONBadRequest as error:
-        return jsonify({"message": "Malformed Request"}), error.code
+        return jsonify({"message": "Malformed Request: %s" % error.data['message']}), error.code
     except HTTPException as error:
         return jsonify(error.data), error.code
 
@@ -731,7 +731,7 @@
     try:
         args = RP['create_testcase'].parse_args()
     except JSONBadRequest as error:
-        return jsonify({"message": "Malformed Request"}), error.code
+        return jsonify({"message": "Malformed Request: %s" % error.data['message']}), error.code
     except HTTPException as error:
         return jsonify(error.data), error.code
 
diff --git a/testing/functest_api_v20.py b/testing/functest_api_v20.py
--- a/testing/functest_api_v20.py
+++ b/testing/functest_api_v20.py
@@ -125,13 +125,13 @@
         r = self.app.post('/api/v2.0/results', data=json.dumps(ref_data), content_type='application/json')
         data = json.loads(r.data)
         assert r.status_code == 400
-        assert data['message'] == 'Malformed Request'
+        assert data['message'].startswith('Malformed Request')
 
         ref_data['ref_url'] = ''
         r = self.app.post('/api/v2.0/results', data=json.dumps(ref_data), content_type='application/json')
         data = json.loads(r.data)
         assert r.status_code == 400
-        assert data['message'] == 'Malformed Request'
+        assert data['message'].startswith('Malformed Request')
 
         ref_data['ref_url'] = self.ref_result_ref_url
         r = self.app.post('/api/v2.0/results', data=json.dumps(ref_data), content_type='application/json')
@@ -144,19 +144,19 @@
         r = self.app.post('/api/v2.0/results', data=json.dumps(ref_data), content_type='application/json')
         data = json.loads(r.data)
         assert r.status_code == 400
-        assert data['message'] == 'Malformed Request'
+        assert data['message'].startswith('Malformed Request')
 
         ref_data['data'] = ['foo', 'bar']
         r = self.app.post('/api/v2.0/results', data=json.dumps(ref_data), content_type='application/json')
         data = json.loads(r.data)
         assert r.status_code == 400
-        assert data['message'] == 'Malformed Request'
+        assert data['message'].startswith('Malformed Request')
 
         ref_data['data'] = {'foo': 'bar'}
         r = self.app.post('/api/v2.0/results', data=json.dumps(ref_data), content_type='application/json')
         data = json.loads(r.data)
         assert r.status_code == 400
-        assert data['message'] == 'Malformed Request'
+        assert data['message'].startswith('Malformed Request')
 
         ref_data['data'] = {'foobar': 'bar'}
         r = self.app.post('/api/v2.0/results', data=json.dumps(ref_data), content_type='application/json')
@@ -197,7 +197,7 @@
         data = json.loads(r.data)
 
         assert r.status_code == 400
-        assert data['message'] == 'Malformed Request'
+        assert data['message'].startswith('Malformed Request')
 
     def test_update_testcase(self):
         self.test_create_testcase()
@@ -435,14 +435,14 @@
         data = json.loads(r.data)
 
         assert r.status_code == 400
-        assert data['message'] == 'Malformed Request'
+        assert data['message'].startswith('Malformed Request')
 
         ref_data = json.dumps({'testcase': self.ref_testcase})
         r = self.app.post('/api/v2.0/results', data=ref_data, content_type='application/json')
         data = json.loads(r.data)
 
         assert r.status_code == 400
-        assert data['message'] == 'Malformed Request'
+        assert data['message'].startswith('Malformed Request')
 
     def test_create_result_multiple_groups(self):
         uuid2 = '1c26effb-7c07-4d90-9428-86aac053288c'